using System;
using System.IO;
using System.Collections;

namespace org.bouncycastle.asn1
{
	public class BERSet: DERSet
	{
		/**
		* create an empty sequence
		*/
		public BERSet()
		{
		}

		/**
		* create a set containing one object
		*/
		public BERSet(
			DEREncodable    obj) : base(obj) {}

		/**
		* create a set containing a vector of objects.
		*/
		public BERSet(
			DEREncodableVector   v) : base(v) {}

		/*
		*/
		public override  void encode(DEROutputStream outStream)
			//throws IOException
		{
			if (typeof(ASN1OutputStream).IsInstanceOfType(outStream) ||
				typeof(BEROutputStream).IsInstanceOfType(outStream))
			{
				outStream.write(DERTags.SET | DERTags.CONSTRUCTED);
				outStream.write(0x80);
	            
				IEnumerator e = getObjects();
				while (e.MoveNext())
				{
					outStream.writeObject(e.Current);
				}
	        
				outStream.write(0x00);
				outStream.write(0x00);
			}
			else
			{
				base.encode(outStream);
			}
		}
	}
}