
using System;
//using System.Collections;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x9
{
	public class X962Parameters: DEREncodable
		{
			private DERObject           parameters = null;

		public X962Parameters(
			X9ECParameters      ecParameters)
		{
			this.parameters = ecParameters.getDERObject();
		}

		public X962Parameters(
			DERObjectIdentifier  namedCurve)
		{
			this.parameters = namedCurve;
		}

		public X962Parameters(
			DERObject           obj)
		{
			this.parameters = obj;
		}

		public bool isNamedCurve()
		{
			return (typeof(DERObjectIdentifier).IsInstanceOfType(parameters));
		}

		public DERObject getParameters()
		{
			return parameters;
		}

		/**
		 * <pre>
		 * Parameters ::= CHOICE {
		 *    ecParameters ECParameters,
		 *    namedCurve   CURVES.&id({CurveNames}),
		 *    implicitlyCA NULL
		 * }
		 * </pre>
		 */
		public DERObject getDERObject()
		{
			return parameters;
		}
	}

}