
using System;
using System.IO;
using org.bouncycastle.io;
using org.bouncycastle.crypto;

namespace org.bouncycastle.crypto.io
{
	public class MacOutputStream : 	FilterOutputStream
	{
		protected Mac mac;

		public MacOutputStream(
			Stream stream,
			Mac          mac) : base(stream)
		{
			this.mac = mac;
		}

		public override void write(int b)
			//throws IOException
		{
			mac.update((byte)(b));
			outStream.WriteByte((byte)(b));
		}

		public override void write(
			byte[] b,
			int off,
			int len)
			//throws IOException
		{
			mac.update(b, off, len);
			outStream.Write(b, off, len);
		}

		public Mac getMac()
		{
			return mac;
		}
	}


}