using System;
using System.Text;
using org.bouncycastle.util.test;

namespace org.bouncycastle.util.test
{
	public abstract class CipherTest: Test
	{
		Test[]      tests;

		protected CipherTest(
			Test[]  tests)
		{
			this.tests = tests;
		}

		public abstract String getName();

		public virtual TestResult perform()
		{
			for (int i = 0; i != tests.Length; i++)
			{
				TestResult  res = tests[i].perform();

				if (!res.isSuccessful())
				{
					return res;
				}
			}

			return new SimpleTestResult(true, getName() + ": Okay");
		}

		protected String ByteArray2String(byte[] bs)
		{
			StringBuilder s = new StringBuilder();
			for (int i = 0; i < bs.Length; i++) 
			{
				s.Append(Convert.ToChar(bs[i]));
			}
			return s.ToString();
		}
	}

}
